package require Rappture

set installdir [file dirname [info script]]
if {$installdir == "."} {
   set installdir [pwd]
}


set driver [Rappture::library [lindex $argv 0]]


set script1 [$driver get input.(script).current]


#-- write the script file locally so bent can read it --
#-- using the expected file name, bent.in ------------- 
set filehandle [open "bent.in" w]
puts $filehandle $script1
close $filehandle



#----------- exec bent -------------------------------------
# local run  
#set bentExec [file join $installdir  bent]

# submit
set bentExec bent

set status [catch {eval Rappture::exec $bentExec bent.in } out]

$driver put -append yes -type string output.(dump).current "run status: "

$driver put -append yes -type string output.(dump).current $status

#source [file join $installdir submit.tcl]


#------- get output --------------------------------
set logfile "PLUME.TXT" 
if { [ file exists $logfile ] == 1 }  {
  
   set filehandle [open $logfile r]
   set log [read $filehandle]
   close $filehandle
   $driver put -append yes -type string output.(dump).current $log
} else {
   $driver put -append yes -type string output.(dump).current "Sorry, no plume file created"
}

#------ create visualization -------------------------
set gnuExec      gnuplot
set gnuCommands [file join $installdir field.gnu]

# make jpg file
set status [catch {eval Rappture::exec $gnuExec $gnuCommands} out]

$driver put -append yes -type string output.(dump).current "Status for running gnuplot "

$driver put -append yes -type string output.(dump).current $status

#read jpg file
set filehandle [open conc.jpg r]
fconfigure $filehandle -encoding binary -translation binary
set viz [read $filehandle]

#encode
set viz64 [Rappture::encoding::encode -as b64 $viz]


#add to output
$driver put output.image(outi).about.label "FIELD Visualization"
$driver put output.image(outi).current $viz64


#--------- clean up ----------

#leave input file & output files including image
#in data/session directory

Rappture::result $driver

exit 0
