      PROGRAM BENT
C---------------------------------------------------------------C
C      THIS IS BENT                                             C
C      CONTAINS ANALYTIC SOLUTION TO RHOA                       C
C      IT DOES NOT USE                                          C
C      THE BOUSSINESQ APPROXIMATION. IT CAN USE ATMOSPHERE FROM C
C      WOODS88; PLUME MODEL BASED ON WOODS+BURSIK91 AND         C
C      GLAZE+BALOGA96.                                          C
C      CONTAINS PARTICLE FALLOUT AND RE-ENTRAINMENT             C
C      M. Bursik:  mib@buffalo.edu                              C
C---------------------------------------------------------------C
      PARAMETER(NVAR=24,NPAR=19)
      REAL YOUT(NVAR),Y(NVAR),DXF(NVAR),DY(NVAR),XFF(NVAR)
      REAL MV(NPAR,1),PV(NPAR),VSO(NPAR),DYDX(NVAR)
      REAL LMF,M,P,K2,MU,PI
      COMMON /PATH/ Z
      COMMON /PATH1/ PI,GRAV,RV,RA,CV,CA,CP,M,RS,RHOG,MU,SIGMA,
     $ RHO0,FF,H,T0,EN,V,SJ,HJ,ALPHA,BETA,EMALL,U,B,RHO,T,LMF,FO
      COMMON /PATH2/ VSO
      EXTERNAL DERIVS
C
C            BEGIN EXECUTABLES
C            DEFINE CONSTANTS		
C            UNIVERSAL:
C
      PI=3.14159    
      GRAV=9.807
C            HEAT CAPS, GAS CONSTS FOR VAPOR, AIR, PARTICLES (S97)
      CV=1860.
      CA=1000.
      CP=1100.
      RA=285.
      RV=460.
C            ENTRAINMENT CONSTANTS
      ALPHA=0.15
      BETA=1.0
C            INPUT VALUES 
      OPEN(4,FILE='bent.in')
      WRITE(*,*)'INITIAL CONDITIONS'
      READ(4,*)B
      WRITE(*,*)'VENT RADIUS:',B," M"
      READ(4,*)U
      WRITE(*,*)'AXIAL JET VELOCITY:',U," M/S"
      READ(4,*)EN0
      WRITE(*,*)'WATER CONTENT:',EN0*100.," WT %"
      READ(4,*)T0
      WRITE(*,*)'ERUPTION TEMPERATURE:',T0," K"
      READ(4,*)THETA1
      WRITE(*,*)'ANGLE THE PLUME MAKES WITH THE HORIZON:'
     &  ,THETA1," DEG"
      READ(4,*)H0
      WRITE (*,*)'HEIGHT OF VENT ABOVE SEA LEVEL:',H0," M"
      READ(4,*)V,HJ,SJ
      WRITE(*,*)'MAX HORIZONTAL WIND SPEED, JET HEIGHT & WIDTH:'
     &  ,V," M/S",HJ," M", SJ," M"
C             MEAN AND STD. DEV. OF THE PLUME PARTICLES
      READ(4,*)ITYPE      
 25   WRITE(*,*)'TYPE OF ERUPTION:',ITYPE
      WRITE(*,*)'1 PHREATOPLINIAN'
      WRITE(*,*)'2 VULCANIAN'
      WRITE(*,*)'3 PLINIAN'
      WRITE(*,*)'4 STROMBOLIAN'
      IF (ITYPE.EQ.1) THEN
         MU=-4.0
         SIGMA=2.0
      ELSEIF (ITYPE.EQ.2) THEN 
         MU=-1.5
         SIGMA=1.0
      ELSEIF (ITYPE.EQ.3) THEN
         MU=0.0
         SIGMA=3.0
      ELSEIF (ITYPE.EQ.4) THEN
         MU=4.0
         SIGMA=2.5
      ELSE
         WRITE(*,*)'PLEASE ENTER 1, 2, 3, OR 4'
         GOTO 25 
      ENDIF
C               PARTICLE DENSITY
      READ(4,*)RS
      WRITE(*,*)'PARTICLE DENSITY:',RS, " KG/M^3"
C               MOST ELONGATED PARTICLES-FF=0.4.  EQUANT-FF=1
      READ(4,*)FF
      WRITE(*,*)'PARTICLE SHAPE FACTOR:',FF
C               DON'T CHANGE FRACTION FROM 1!
C               THIS WOULD BE THE PARAMETER TO MODIFY IF 
C               IT WAS DESIRED TO TRACK A PARTICULAR PARTICLE
C               PHASE THAT MIGHT BE A FRACTION OF TOTAL PARTICLE POP.
      READ(4,*)FRACTION
      WRITE(*,*)'WHAT FRACTION OF TOTAL PARTICLE POPULATION '
      WRITE(*,*)'DO SUCH PARTICLES REPRESENT?',FRACTION
      READ(4,*)PHIMIN,PHIMAX
      WRITE(*,*)'WHICH GRAIN-SIZES TO PRINT (PHIMIN PHIMAX):'
     &  ,PHIMIN,PHIMAX
      CLOSE(4,STATUS='KEEP')
C
C               SET UP INTEGRATION DOMAIN, SPACE VARIABLES  
C               INTEGRATE BETWEEN STARTS AND ENDS, W/ STEP H
C
      STARTS=0.0
      ENDS=100000.
C      ENDS=5000.
C               H IS THE STEP SIZE
      H=1.0
C               FOR PRINT SKIPPING
      KK=0
C               INITIALIZE S
      S=STARTS
C               INITIALIZE THE POSITION VARIABLES
      X=0.0
      Z=H0
      THETA=THETA1*PI/180.
C               INITIAL VALUES  
      RHO0=RHOA(Z)
      EN=EN0
      W=EN0
      T=T0
      R=(W/EN)*RV+(1-W/EN)*RA
      C=W*CV+(EN-W)*CA+(1-EN)*CP
      RHOG=RHOA(Z)*(RA*TA(Z)/R/T)
      RHO=1/((1-EN)/RS+EN/RHOG)
      M=RHO*B*B*U
      K2=RHO*U*U*B*B
      P=M*C*T
      LMF=M**(3/4)*P**(-1/2)
      FO = P
      EMALL=M*(1-EN)
      WRITE(*,*)'ATM RHOA0, TA0:',RHOA(Z),TA(Z)
      WRITE(*,*)'PLUME INIT. DENSITY:',RHO,"  ",RHOG
      WRITE(*,*)'MASS FLUX:',M*PI
      WRITE(*,*)'MOMENTUM FLUX:',K2*PI
      WRITE(*,*)'THERMAL FLUX:',P*PI
      WRITE(*,*)'MASS FLUX OF PARTICLES:',EMALL*PI
C                  INITIAL VALUES TO GET INTEGRATED BY R-K
      Y(1)=M
      Y(2)=K2
      Y(3)=THETA
      Y(4)=P
C                  CALCULATE FALL SPEEDS OF THE GRAINS AT VENT
      CALL FALLSPEED(VSO,PV)
C                  INITIAL MASSES IN GRAIN SIZE FRACTIONS DEPEND ON
C                  BULK DENSITY, HENCE EXSOLVED WATER CONTENT
      DO 16 I=1,19
      MV(I,1)=PV(I)*EMALL*FRACTION
 16   CONTINUE
      EMALL=0.0
      DO 17 I=1,19
      Y(I+4)=MV(I,1)
      EMALL=EMALL+Y(I+4)
 17   CONTINUE
      Y(24)=EMALL
      DO 18 I=1,24
         DYDX(I)=0.0
 18      CONTINUE
C
C            
C                  THIS BEGINS THE NUMERICAL INTEGRATION 
C
C
C                  INITIALIZE THE VALUES OF DY
      CALL DERIVS(S,Y,DYDX)
C                  MAX ITERATION SAFETY CATCH
      MAXITER=100000.
C                  OUTPUT  
C                  OPEN OUTPUT FILES
      OPEN (1,FILE='PLUME.TXT')
      OPEN (2,FILE='FALLOUT.TXT')
      OPEN (3,FILE='FIELD.TXT')
C      WRITE(1,80)'S','X','Z','U','B','RHOA','RHO'
C      WRITE(*,80)'Z','X','S','VV','UZ','UX','UE'
 80   FORMAT(3A7,4A10)
      WRITE(2,85)'DISTANCE',PHIMIN
 85   FORMAT(A10,F11.0)
C      WRITE(1,93)S,X,Z,RHOA(Z),U,B,RHO
C      WRITE(*,93)S,X,Z,RHOA(Z),U,B,RHO
 90   UZ=Y(2)/Y(1)*SIN(Y(3))
      IF (S .LT. ENDS .AND. S .LT. MAXITER .AND. UZ .GE. 0.0) THEN
      CALL FALLSPEED (VSO,PV)
      CALL RK4(Y,DYDX,NVAR,S,H,YOUT,DERIVS)
      DO 91 J=1,24
      DY(J)=(Y(J)-YOUT(J))
      Y(J)=YOUT(J)
 91   CONTINUE
      Y1=Y(1)
      Y2=Y(2)
      Y3=Y(3)
      Y4=Y(4)
      Y24=Y(24)
      CALL UPDATE(Y1,Y2,Y4,Y24,U,RHO,EN,RS,RHOG,B,
     +  W,M,R,RV,RA,C,CV,CA,CP,T)
C                       BACK CALCULATE X AND Z
      X=X+(COS(Y3)*H)
      Z=Z+(SIN(Y3)*H)
      IF(Z/Z.EQ.1.0) ZMAX=Z
C      WRITE(*,96)Z/1000.
C           FALLOUTCOR CORRECTS X TO ACCOUNT FOR THE PLUME RADIUS AND
C           HORIZONTAL DISTANCE TRAVELED AFTER LEAVING THE PLUME.
      CALL FALLOUTCOR(X,Y,DXF,B,XFF,Z,H)
      S=S+H
C           CONVERT TO FALLOUT PER UNIT AREA INSTEAD OF PER SLICE
      DO 92 J=5,23
 92   DY(J)=DY(J)/(2*B)
C           PRINT OUT CALCULATIONS FROM THIS STEP***
CC     NP=10
      NP=99
      KK=KK+1
      IF(KK.LE.NP) GO TO 95
C     Y(11)=8to4mm, Y(17)=64to32microns
      CALL FIELD(X,B,Z,U,Y(3),Y(17))
      UZ=U*SIN(Y(3))
      UX=U*COS(Y(3))
      UE=ALPHA*ABS(U-VV(V,Z,SJ,HJ)*COS(Y(3)))
     $ +BETA*ABS(VV(V,Z,SJ,HJ)*SIN(Y(3)))
      VW=VV(V,Z,SJ,HJ)
C      WRITE(1,93)Z,ABS(X),S,VW,UZ,ABS(UX),UE
C      WRITE(1,93)Z,X+1,S,U,B,RHOA(Z),RHO
      WRITE(1,93)Z,ABS(X),UZ,Y24,Y(5),Y(15)
      IPHIMIN=INT(PHIMIN)
      IPHIMAX=INT(PHIMAX)
      WRITE(2,94) (XFF(INDEX),DY(INDEX),INDEX=IPHIMIN+13,IPHIMAX+13)
      KK=0
 93   FORMAT(3F7.0,4E10.3)
 94   FORMAT(10(F10.0,E11.3))
 95   CONTINUE
C            RECALCULATE DY'S (PREPARING TO CALL RK4 AGAIN)
      GO TO 90
      ELSE
      WRITE(*,*)'CALCULATIONS ARE COMPLETE'
      WRITE(*,*)'ERUPTION PLUME HEIGHT IS  ',ZMAX
      WRITE(*,*)
      WRITE(*,*)'OUTPUT IS WRITTEN TO FILES:'
      WRITE(*,*)'PLUME.TXT, FALLOUT.TXT, FIELD.TXT'
      WRITE(*,*)
      WRITE(*,*)'PLUME.TXT CONTAINS THE PLUMES PROPERTIES'
      WRITE(*,*)'I.E. POSITION IN S, X AND Z, AXIAL VEL. AND RADIUS'
      WRITE(*,*)
      WRITE(*,*)'FALLOUT.TXT CONTAINS FALLOUT GROUPED INTO PHI SIZES'
      WRITE(*,*)'FIELD.TXT CONTAINS CONCENTRATION FIELD'
      END IF
C                CLOSE THE OUPUT FILES
      CLOSE(1, STATUS='KEEP')
      CLOSE(2, STATUS='KEEP')
      CLOSE(3, STATUS='KEEP')
C                THIS ENDS THE NUMERICAL INTEGRATION
      STOP
      END
C-----------------------------------------C
C                                         C
C                                         C
C      SUBROUTINES AND FUNCTIONS          C
C                                         C
C                                         C
C-----------------------------------------C
      SUBROUTINE RK4(Y,DYDX,N,X,H,YOUT,DERIVS)
      PARAMETER (NMAX=26)
      DIMENSION Y(N),DYDX(N),YOUT(N),YT(NMAX),DYT(NMAX),DYM(NMAX)
      HH=H*0.5
      H6=H/6.
      XH=X+HH
      DO 11 I=1,N
        YT(I)=Y(I)+HH*DYDX(I)
11    CONTINUE
      CALL DERIVS(XH,YT,DYT)
      DO 12 I=1,N
        YT(I)=Y(I)+HH*DYT(I)
12    CONTINUE
      CALL DERIVS(XH,YT,DYM)
      DO 13 I=1,N
        YT(I)=Y(I)+H*DYM(I)
        DYM(I)=DYT(I)+DYM(I)
13    CONTINUE
      CALL DERIVS(X+H,YT,DYT)
      DO 14 I=1,N
        YOUT(I)=Y(I)+H6*(DYDX(I)+DYT(I)+2.*DYM(I))
14    CONTINUE
      RETURN
      END
C
C
C         DIFFERENTIAL EQUATIONS      
C
C
      SUBROUTINE DERIVS(S,Y,DYDX)
      PARAMETER(NVAR=24,NPAR=19)
      DIMENSION Y(NVAR),DYDX(NVAR)
      REAL VSO(NPAR),LMF
      COMMON /PATH/ Z
      COMMON /PATH1/ PI,GRAV,RV,RA,CV,CA,CP,M,RS,RHOG,MU,SIGMA,
     $ RHO0,FF,H,T0,EN,V,SJ,HJ,ALPHA,BETA,EMALL,U,B,RHO,T,LMF,FO
      COMMON /PATH2/ VSO
C           PARAMETERS NOT DEPENDENT ON MI
C           REENTRAINMENT AREA AND B-V FREQ
      PS=0.226*(SIN(Y(3)))**2+0.5*(COS(Y(3)))**2
      EPS=(0.014)**2
C           CALCULATE THE MASS OF PYROCLASTS
C           AMOUNT OF FALLOUT
        Y1Y2=SQRT(Y(1)**2/Y(2))
        Y2Y1=Y(2)/Y(1)
        EMALLDS=0.0
      DO 200 JJJ=5,23
      J=JJJ-4
      PHI2=PHI(LMF,FO,VSO,J)
      DYDX(JJJ)=-2.0*PS*VSO(J)*Y(JJJ)/Y1Y2/Y2Y1
     +  +((6*PHI2*EPS*U)/(5*B**2))
      EMALLDS=DYDX(JJJ)+EMALLDS   
 200      CONTINUE
      DYDX(24)=EMALLDS
      UE=ALPHA*ABS(U-VV(V,Z,SJ,HJ)*COS(Y(3)))
     $ +BETA*ABS(VV(V,Z,SJ,HJ)*SIN(Y(3)))  
      DYDX(1)=2*RHOA(Z)*UE*B+EMALLDS
      YDY=DYDX(1) 
      DYDX(2)=-B**2*(RHO-RHOA(Z))*GRAV*SIN(Y(3))
     $ +VV(V,Z,SJ,HJ)*COS(Y(3))*YDY+U*EMALLDS
      DYDX(3)=-(B**2*(RHO-RHOA(Z))*GRAV*COS(Y(3))
     $ -VV(V,Z,SJ,HJ)*SIN(Y(3))*YDY)/Y(2)
      DYDX(4)=2*UE*RHOA(Z)*B*CA*TA(Z)-B**2*UE*RHOA(Z)*GRAV
     $ +CP*T*EMALLDS
      RETURN
      END
C
C
C       UPDATE THE PARAMETERS BETWEEN STEPS
C
C
      SUBROUTINE UPDATE(Y1,Y2,Y4,Y24,U,RHO,EN,RS,RHOG,B,
     +  W,M,R,RV,RA,C,CV,CA,CP,T)
C       UPDATE VALUES OF PARAMETERS
      COMMON /PATH/ Z
      REAL M
      Y1Y2=SQRT(Y1**2/Y2)
      U=Y2/Y1
      RHO=1/((1-EN)/RS+EN/RHOG)
      B=1/(SQRT(RHO))*Y1Y2
      EN=(Y1-Y24)/Y1
      W=1-(Y1-M)/Y1-Y24/Y1
      R=W/EN*RV+(1-W/EN)*RA
      C=W*CV+(EN-W)*CA+(1-EN)*CP
      T=Y4/C/Y1
      RHOG=RHOA(Z)*RA*TA(Z)/R/T
      RETURN
      END
C
C
C           PARTICLE SETTLING SPEEDS
C
C
      SUBROUTINE FALLSPEED(VSO,PV)
      PARAMETER(NVAR=24,NPAR=19)
      COMMON /PATH1/ PI,GRAV,RV,RA,CV,CA,CP,M,RS,RHOG,MU,SIGMA,
     $ RHO0,FF,H,T0,EN,V,SJ,HJ,ALPHA,BETA,EMALL,U,B,RHO,T,LMF,FO
      DIMENSION VSO(NPAR),PV(NPAR)
      REAL MU,I2DI,LMF,FI
      REAL SCFI(NPAR),SCMM(NPAR)
 17   FORMAT(5A10)
C             MEMORIZES THE PHI AND MM SCALE
      INDEX=1
      DO 15 IFI=-8,10,1
         FI=FLOAT(IFI)
      DI=2.0**(-FI)
      SCMM(INDEX)=DI
      SCFI(INDEX)=FI
      SV=SQRT(2*PI)
      I2DI=LOG10(DI)/LOG10(2.0)
      PV(INDEX)=EXP(-((FI-MU)**2)/(2.0*SIGMA**2))/(SV*SIGMA)
C            CALCULATE DENSITY AND VISCOSITY OF AIR AT VENT HEIGHT
C            SEA LEVEL DENSITY FROM NASA 1962 STANDARD ATMOSPHERE
C            VISCOSITY FROM MIDDLETON & WILCOCK
      ENU=0.000018/RHOG
C            GET FALL SPEEDS
      CD=1.0
      DO 14 IV = 1, 20
      VSO(INDEX)=SQRT(4.0*(0.001*DI)*GRAV*(RS-RHO)/(3.0*RHO*CD))
      RE=VSO(INDEX)*(0.001*DI)/ENU
      CDOLD=CD
      CD=(24.0/RE)*(FF**(-0.32))+2*SQRT(1.07-FF)
      DIFF=ABS((CDOLD-CD)/CD)
C            USE THIS OUTPUT TO CHECK THAT CD IS CONVERGING
C       WRITE(*,*) 'DIFF OF ', INDEX, ' = ', DIFF
 14      CONTINUE
      IF (DIFF.GE.0.01) THEN
      WRITE(*,*)'ERROR IN FALL SPEED (INDEX=', INDEX,') >1%'
      ENDIF
      INDEX=INDEX+1
 15      CONTINUE
C         WRITE(*,20)(RHOA(Z),I-9,VSO(I),I=1,19)
C 20      FORMAT(F10.3,I10,F20.5)
      RETURN
      END
C
C
C          CORRECT PARTICLE FALLOUT TO EDGE OF PLUME
C
C
      SUBROUTINE FALLOUTCOR(X,Y,DXF,B,XFF,Z,H)
      PARAMETER(NVAR=24,NPAR=19)
      REAL DXF(NVAR),Y(NVAR),XFF(NVAR),VSO(NPAR)
C          TRANSFORMS X AND Z POSITIONS TO THE PLUME EDGE
      XF=X+SIN(Y(3))*(B)
      ZF=Z-COS(Y(3))*(B)
C          INITIALIZES THE ARRAY DXF(J) (X POS FOR EACH GRAIN SIZE)
      DO 50 J=1,19
 50   DXF(J)=XF
C          DXF(INDEX) IS THE CORRECTION WHICH
C          ACCOUNTS FOR HORIZONTAL MOVEMENT CAUSED BY THE WIND AFTER
C          THE PARTICLE LEAVES THE PLUME
C          DO WHILE THE PARTICLE HAS NOT HIT THE GROUND
      DO 400 WHILE (ZF.GT.0)
C          CALCULATE THE DISTANCE EACH PARTICLE SIZE HAS MOVED
C          IN THIS STEP
      DO 100 J=1,19
      DXF(J)=DXF(J)+(H*VV(V,ZF,SJ,HJ))/(VSO(J))
      XFF(J)=DXF(J)
      IF (ZF.GT.10000) THEN 
C      WRITE(*,*)J,ZF,VV(V,ZF,SJ,HJ),VSO(J),XFF(J)
      ENDIF
 100      CONTINUE
C          CHANGE IN Z FOR THIS STEP
      ZF=ZF-H
 400  CONTINUE
      RETURN
      END
C
C
C         TO CALCULATE A 2-D PARTICLE FIELD
C
C 
      SUBROUTINE FIELD(XC,BF,ZC,UF,THET,EMASS)
C         SUBROUTINE TO ESTIMATE INSTANTANEOUS FIELD OF PARTICLE MASS
C         WITHIN PLUME
      XF=BF
      IXF=INT(XF)
      DO 1000 I=-20000,20000,200
      RI=FLOAT(I)
      AXC=ABS(XC)
      CA=(EMASS/UF)
     & *EXP(-(RI-AXC)**2/(XF/2.)**2)/3.1416/XF**2
      TCA=LOG10(CA)
      WRITE(3,*)RI,ZC,CA,TCA
 1000 CONTINUE
C      UNCOMMENT THE NEXT LINE TO PRODUCE OUTPUT IMMEDIATELY USEABLE
C      BY GNUPLOT PM3D
      WRITE(3,*)
      RETURN
      END
C      
C
C        ATMOSPHERIC TEMPERATURE
C
C
      REAL FUNCTION TA(Z)
C           FROM   KALEIDAGRAPH BEST FIT TO ATM FROM SPARKSETAL97
C           Y = M0 + M1*X + ... M8*X^8 + M9*X^9
C      TA=279.81-0.011335*Z+5.3298E-07*Z**2
C     &  -9.0085E-12*Z**3+5.4568E-17*Z**4
C     FOR ISOTHERMAL ATMOSPHERE; H=8500. M (WALLACE&HOBBS)
      TA=288.
      RETURN
      END
C
C
C        ATMOSPHERIC DENSITY
      REAL FUNCTION RHOA(Z)
C      COMMON /PATH1/ PI,GRAV,RV,RA,CV,CA,CP,M,RS,RHOG,MU,SIGMA,
C     $ RHO0,FF,H,T0,EN,V,SJ,HJ,ALPHA,BETA,EMALL,U,B,RHO,T,LMF,FO
C       RHOA0 IS SEA-LEVEL AIR DENSITY
      RHOA0=1.3
C      RHOA=1.3
C      RHOA=RHOA0*TA(0.0)/TA(Z)*EXP(-GRAV/RA*54.3159*ATAN(0.0000143345
C     & *(-151262.+2*Z))+90.0861*ATAN(0.000019015*(-13826.1+2*Z))-
C     & 31.0212*LOG(6.93669E+09-151262.*Z+Z**2)-
C     & 31.0212*LOG(7.39218E+08-13826.1*Z+Z**2))
      RHOA=RHOA0*EXP(-Z/8500.)
      RETURN
      END  
C
C
C      WIND SPEED AS A FUNCTION OF HEIGHT
C
C
      REAL FUNCTION VV(V,Z,SJ,HJ)
C     VV=V
      VV=V*EXP(-(Z-HJ)**2./SJ**2.)
      RETURN
      END
C
C
C        RE-ENTRAINMENT PARAMETER
C
C
      REAL FUNCTION PHI(LMF,FO,VSO,I)
      PARAMETER(NVAR=24,NPAR=19)
      REAL VSO(NPAR),PPHI,LMF
      PPHI=(FO/LMF)**(1/3)/VSO(I)
      PHI=0.43/(1.+(0.78/PPHI)**6.)
      RETURN
      END

